# Async Endpoint

![Async Endpoint Logo](logo.png)

**Asynchronous Endpoints**, especially when paired with a **functional style of programming**,
provide a sound method of writing programs in JavaScripts that are

    - testable
    - maintainable
    - extendable
    - composeable
    - easy to reason about
    - standard based*

This repository provides a brief intoduction to asynchronous endpoints\*\*, along with a helper library `async-endpoint` to help make a few things easier.

## Table of contents

* <a href="#introduction">Introduction</a>

  * <a href="#introduction-synchronous-endpoints">Synchronous Endpoints</a>
  * <a href="#introduction-synchronous-iteration">Synchronous Iteration</a>
  * <a href="#introduction-asynchronous-iteration">Asynchronous Iteration</a>
  * <a href="#introduction-asynchronous-input">Asynchronous Input</a>
  * <a href="#import">Import</a>
  * <a href="#application-programming-interface">API</a>
